
Object subclass: #ConfigurationOfGADM
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfGADM'!

!ConfigurationOfGADM class methodsFor: 'development support' stamp: 'HernanMoralesDurand 2/3/2015 18:56'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfGADM class methodsFor: 'private' stamp: 'HernanMoralesDurand 2/3/2015 18:56'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfGADM class methodsFor: 'private' stamp: 'HernanMoralesDurand 2/3/2015 18:56'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfGADM class methodsFor: 'private' stamp: 'HernanMoralesDurand 2/3/2015 18:56'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfGADM class methodsFor: 'metacello tool support' stamp: 'HernanMoralesDurand 2/3/2015 18:56'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfGADM class methodsFor: 'loading' stamp: 'HernanMoralesDurand 2/3/2015 18:56'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfGADM class methodsFor: 'loading' stamp: 'HernanMoralesDurand 2/3/2015 18:56'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfGADM class methodsFor: 'loading' stamp: 'HernanMoralesDurand 2/3/2015 18:56'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfGADM class methodsFor: 'accessing' stamp: 'HernanMoralesDurand 2/3/2015 18:56'!
project

	^self new project! !

!ConfigurationOfGADM class methodsFor: 'development support' stamp: 'HernanMoralesDurand 2/3/2015 18:56'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfGADM methodsFor: 'baselines' stamp: 'HernanMoralesDurand 2/4/2015 03:40'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec preLoadDoIt: #preLoad.
		spec repository: 'http://smalltalkhub.com/mc/hernan/GADM/main/'.
		spec 
			project: 'NeoCSV' with: [
				spec
					className: #ConfigurationOfNeoCSV;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/Pharo/MetaRepoForPharo30/main/';
					repository: 'http://smalltalkhub.com/mc/SvenVanCaekenberghe/Neo/main/' ];
			project: 'XBase' with: [
				spec
					className: #ConfigurationOfXBase;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/hernan/XBase/main/' ].
		spec package: 'GADM'. ].
! !

!ConfigurationOfGADM methodsFor: 'baselines' stamp: 'HernanMoralesDurand 2/7/2015 20:19'!
baseline02: spec
	<version: '0.2-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec preLoadDoIt: #preLoad.
		spec repository: 'http://smalltalkhub.com/mc/hernan/GADM/main/'.
		spec project: 'NeoCSV' with: [
				spec
					className: #ConfigurationOfNeoCSV;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/Pharo/MetaRepoForPharo30/main/';
					repository: 'http://smalltalkhub.com/mc/SvenVanCaekenberghe/Neo/main/' ].
		spec package: 'GADM'. ].
! !

!ConfigurationOfGADM methodsFor: 'accessing' stamp: 'HernanMoralesDurand 2/3/2015 18:56'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfGADM methodsFor: 'symbolic versions' stamp: 'HernanMoralesDurand 2/7/2015 20:18'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.2-baseline'.
! !

!ConfigurationOfGADM methodsFor: 'doits' stamp: 'HernanMoralesDurand 2/4/2015 03:39'!
extractGZip: fileRef in: dst
	" If fileRef is a ZIP archive, uncompress its contents in dst and delete it "
	
	(fileRef fullName endsWith: '.gz')
		ifTrue: [ | unzipped |
			unzipped := GZipReadStream unzip: fileRef basename to: FileSystem workingDirectory.
			(FileSystem workingDirectory / unzipped) 
				renameTo: unzipped asFileReference basenameWithoutExtension ].! !

!ConfigurationOfGADM methodsFor: 'doits' stamp: 'HernanMoralesDurand 2/4/2015 03:38'!
extractZip: fileRef in: dst
	" If fileRef is a ZIP archive, uncompress its contents in dst and delete it "
	(fileRef fullName endsWith: '.zip')
		ifTrue: [ | zipArchive |
			zipArchive := ZipArchive new.
			[ zipArchive 
				readFrom: fileRef fullName;
				extractAllTo: dst ] 
			ensure: [ zipArchive close ].
			fileRef delete ].! !

!ConfigurationOfGADM methodsFor: 'doits' stamp: 'HernanMoralesDurand 3/13/2015 01:11'!
platformFilesUrl
	" Answer a <String> with download URL "

	^ String streamContents: [ : stream |
		stream 
			nextPutAll: 'http://dl.dropboxusercontent.com/u/103833630/';
			nextPutAll: (Smalltalk os isWin32 
						ifTrue: [ 'gadm2_dbf.zip' ]
						ifFalse: [ 'gadm2_dbf.tar.gz' ]) ].! !

!ConfigurationOfGADM methodsFor: 'doits' stamp: 'HernanMoralesDurand 2/4/2015 03:36'!
preLoad

	| url fileRef response |

	url := self platformFilesUrl asZnUrl.
	fileRef := FileSystem disk workingDirectory / url pathSegments last.
	(response := ZnEasy get: url) isSuccess
		ifTrue: [ fileRef writeStreamDo: [ : stream | stream nextPutAll: response contents ] ]
		ifFalse: [ self error: 'Cannot download test files' ].
	self uncompress: fileRef.! !

!ConfigurationOfGADM methodsFor: 'accessing' stamp: 'HernanMoralesDurand 2/3/2015 18:56'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfGADM methodsFor: 'symbolic versions' stamp: 'HernanMoralesDurand 2/24/2015 21:53'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.3'.
! !

!ConfigurationOfGADM methodsFor: 'doits' stamp: 'HernanMoralesDurand 2/4/2015 03:36'!
uncompress: fileRef
	" Private - Uncompress fileRef to the current working directory "

	| dst |
	dst := FileSystem workingDirectory.
	self extractZip: fileRef in: dst.
	self extractGZip: fileRef in: dst.! !

!ConfigurationOfGADM methodsFor: 'versions' stamp: 'HernanMoralesDurand 2/6/2015 01:32'!
version10: spec
	<version: '1.0' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.0'.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '2/6/2015 01:32'.
		spec 
			project: 'NeoCSV' with: '11';
			project: 'XBase' with: '1.0'.
		spec package: 'GADM' with: 'GADM-HernanMoralesDurand.10'. ].
! !

!ConfigurationOfGADM methodsFor: 'versions' stamp: 'HernanMoralesDurand 2/8/2015 02:35'!
version11: spec
	<version: '1.1' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.1'.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '2/8/2015 02:35'.
		spec project: 'NeoCSV' with: '11'.
		spec package: 'GADM' with: 'GADM-HernanMoralesDurand.11'. ].
! !

!ConfigurationOfGADM methodsFor: 'versions' stamp: 'HernanMoralesDurand 2/8/2015 02:36'!
version12: spec
	<version: '1.2' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.2'.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '2/8/2015 02:36'.
		spec project: 'NeoCSV' with: '11'.
		spec package: 'GADM' with: 'GADM-HernanMoralesDurand.12'. ].
! !

!ConfigurationOfGADM methodsFor: 'versions' stamp: 'HernanMoralesDurand 2/24/2015 21:53'!
version13: spec
	<version: '1.3' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.3'.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '2/24/2015 21:53'.
		spec project: 'NeoCSV' with: '11'.
		spec package: 'GADM' with: 'GADM-HernanMoralesDurand.13'. ].
! !
